<template>
  <div>
    <!--{{ this.$route.name === 'registration' ? registrationPage : profilePage}}-->
    <input type="text"
           name="snils"
           id="snils"
           v-validate="'required|snils'"
           v-model="userSnils"
           v-mask="'###-###-### ##'"
           :guide="true"
           placeholder="123-456-789 00"
           ref="snils"
           @input="setUserSnils"
           :keepCharPositions="true"
           :class="getValidateClass('snils')"
           data-code="snilsInvalidFormat, snilsTooShort, snilsTooLong, snilsCodeIncorrect"
    >

    <validate-message
      v-show="vErrors.has('snils')"
    >{{ vErrors.first('snils') }}
    </validate-message>
  </div>
</template>
<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import ChangeDataInProfile from '@/mixins/Profile/ChangeDataInProfile'

  export default {
    name: 'snils',
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin,
      ChangeDataInProfile
    ],
    components: {
      ValidateMessage
    },
    // computed: {
    //   registrationPage () {
    //     this.userSnils = this.user.snils
    //     this.getUserSnils = this.setValue('snils')
    //   },
    //   profilePage () {
    //     this.userSnils = this.$store.state.authorizedUser.snils
    //     this.getUserSnils = this.changeDataOfUser
    //   }
    // },
    computed: {
      userSnils: {
        get () {
          return this.$route.name === 'registration' ? this.user.snils : this.$store.state.authorizedUser.snils
        },
        set (val) {
          this.$route.name === 'registration' ? this.user.snils = val : this.$store.state.authorizedUser.snils = val
        }
      }
    },
    methods: {
      setUserSnils (e) {
        this.$route.name === 'registration' ? this.setValue('snils') : this.changeDataOfUser(e)
      }
    },
    updated () {
      this.$store.state.user.validatedForms.step2.snils = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    }
  }
</script>

<style scoped lang="scss">

</style>

